#!/usr/bin/perl

use strict;
use Device::SerialPort;


sub read_line($) {
	my ( $ser ) = @_;
	my ( $len, $result );
	my $vucr = 0;
	my ( $l, $r );
	while ( ! ( $r eq "\n" && $vucr ) ) {
		( $l, $r ) = $ser->read(1);
		if ( $l ) {
#			print "Gnaencore: ";
#			printf("(0x%02x)%d ",ord($r),ord($r));
			if ( $vucr ) {
				if ( $r eq "\n" ) {
#					print "LF apres CR, fin.\n";
					last;
				} else {
#					print "Normal <$r> apres CR, garder le CR.\n";
					$result .= "\r";
					$len ++;
					$vucr=0;
				}
			}
			if ( $r eq "\r" ) {
#				print "CR, attendre un LF.\n";
				$vucr = 1;
			} else {
#				print "Normal <$r>, ajout.\n";
				$result .= $r;
				$len++;
			}
		} else {
			next;
#			print "Gnapu\n";
		}
	}
	return $result;
}

sub send_line($$) {
	my ( $ser, $line ) = @_;
	my $len = $ser->write($line."\r\n");
	print "Ecrit $len caracteres\n";

	if ( $len == 0 ) {
		die "Echec a l'ecriture de $line";
	}
}

sub send_string($$) {
	my ( $ser, $string ) = @_;
	$ser->write($string);
}

sub expect_line($$) {
	my ( $ser, $line ) = @_;
	my $result = "";
	while ( $result !~ /$line/ ) {
		$result = read_line($ser);
		print "Lu: $result\n";
	}
	return $result;
}

my $ser = new Device::SerialPort('/dev/ttyS0');

print "Au debut:\n";
print "  baudrate: ".$ser->baudrate()."\n";

$ser->baudrate(38400);
$ser->parity('even');
$ser->databits(7);
$ser->stopbits(1);
$ser->save('/tmp/modem.cfg');
$ser->read_const_time(50);
$ser->read_char_time(5);

print "A la fin:\n";
print "  baudrate: ".$ser->baudrate()."\n";

my $result = "";
my $len;

send_line($ser,"ATZM0");
expect_line($ser,"OK");
send_line($ser,"ATDT0836064444");
expect_line($ser,"CONNECT");
expect_line($ser,"TRANSPAC");

sleep(1);
send_string($ser,"+++");
expect_line($ser,"OK");
send_line($ser,"ATH");

print "J'y suis!\n";

